diff --git a/game/client/src/main/java/net/minecraft/client/world/AuroraProvider.java b/game/client/src/main/java/net/minecraft/client/world/AuroraProvider.java
new file mode 100644
index 000000000..b5cca7313
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/world/AuroraProvider.java
@@ -0,0 +1,108 @@
+package net.minecraft.client.world;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class AuroraProvider {
+    private @Nullable ImprovedPerlinNoise noise = null;
+    private long lastSeed = -1;
+
+    public AuroraProvider() { }
+
+    public void init(final @NotNull World world) {
+        if (this.noise == null || world.getRandomSeed() != this.lastSeed) {
+            this.noise = new ImprovedPerlinNoise(new Random(world.getRandomSeed()));
+            this.lastSeed = world.getRandomSeed();
+        }
+    }
+
+    public double getAuroraPresence(final double x, final double z, final long worldTime, float celestialAngle) {
+        assert this.noise != null;
+
+        final double auroraLevel = 0.0f;
+        final double auroraRadius = 0.03f;
+
+        final double mult;
+        if (celestialAngle < 0.25f || celestialAngle > 0.75f) {
+            return 0.0f;
+        } else {
+            // celestialAngle from 0.25f to 0.75f
+            celestialAngle = (celestialAngle - 0.25f) * 2;
+            // celestialAngle from 0.0f to 1.0f
+            celestialAngle = (celestialAngle * 2) - 1f;
+            // celestialAngle from -1.0f to 1.0f
+            celestialAngle = Math.abs(celestialAngle);
+            // celestialAngle from 1.0f to 0.0f to 1.0f
+            celestialAngle = -celestialAngle + 1.0f;
+            // celestialAngle from 0.0f to 1.0f to 0.0f
+            mult = celestialAngle;
+        }
+
+        double sample = this.noise.getValue(x / 1000d, worldTime / 5000d, z / 1000d);
+        sample += this.noise.getValue(x / 30d, worldTime / 50d, z / 30d) * 0.05d;
+        if (sample < auroraLevel - auroraRadius || sample > auroraLevel + auroraRadius) {
+            return 0.0f;
+        } else {
+            // Range = auroraLevel - auroraRadius to auroraLevel + auroraRadius
+            sample -= auroraLevel;
+            // Range = -auroraRadius to auroraRadius
+            sample /= auroraRadius;
+            // Range = -1.0 to 1.0
+            sample = Math.abs(sample);
+            // Range = 1.0 to 0.0 to 1.0
+            sample = -sample;
+            // Range = -1.0 to 0.0 to -1.0
+            sample += 1.0d;
+            // Range = 0.0 to 1.0 to 0.0
+            return sample * mult;
+        }
+    }
+
+    public double getAuroraHeightOffset(final double x, final double z, final double worldTime) {
+        assert this.noise != null;
+
+        return this.noise.getValue(x / 100d, worldTime / 5000d, z / 100d) * 25d;
+    }
+
+    public float getAuroraRedOffset(final double x, final double z, final double worldTime) {
+        assert this.noise != null;
+
+        double sample = this.noise.getValue(x / 500d, worldTime / 5000d + 10000, z / 500d);
+        double sample2 = this.noise.getValue(x / 200d, worldTime / 5000d, z / 200d);
+        if (sample < 0.0f) sample = 0.0f;
+        if (sample > 0.25f) sample = 0.25f;
+        if (sample2 < 0.0f) sample2 = 0.0f;
+        if (sample2 > 0.1f) sample2 = 0.1f;
+
+
+        return (float) (sample * 3 + sample2 * 2);
+    }
+
+    public float getAuroraGreenOffset(final double x, final double z, final double worldTime) {
+        assert this.noise != null;
+
+        double sample = this.noise.getValue(x / 500d, worldTime / 5000d + 10000d, z / 500d);
+        double sample2 = this.noise.getValue(x / 500d, worldTime / 5000d, z / 500d);
+        if (sample < 0) sample = 0;
+        if (sample > 0.125f) sample = 0.125f;
+        if (sample2 < 0.0f) sample2 = 0.0f;
+        if (sample2 > 0.25f) sample2 = 0.25f;
+
+
+        return (float) (sample * 4 - sample2 * 2);
+    }
+
+    public float getAuroraBlueOffset(final double x, final double z, final double worldTime) {
+        assert this.noise != null;
+
+        double sample = this.noise.getValue(x / 500d, worldTime / 5000d, z / 500d);
+        if (sample < 0.0f) sample = 0.0f;
+        if (sample > 0.25f) sample = 0.25f;
+
+        return (float) sample;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index b61b6d726..bc7b6482a 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,20 +1,19 @@
 package net.minecraft.client.world;
 
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.AuroraProvider;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.type.WorldType;
@@ -30,22 +29,35 @@ import org.joml.Vector3fc;
 public class WorldClient extends World {
     public static final WorldClient EMPTY_WORLD = new WorldClient();
 
-    public WorldClient(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType, @Nullable Biome startingBiome) {
-        super(saveHandler, name, seed, dimension, worldType, startingBiome);
+    public WorldClient(
+        final @NotNull LevelStorage levelStorage,
+        final @Nullable String name,
+        final long seed,
+        final @NotNull Dimension dimension,
+        final @Nullable Biome startingBiome
+    ) {
+        super(levelStorage, name, seed, dimension, startingBiome);
     }
 
-    public WorldClient(World world, Dimension dimension) {
+    public WorldClient(
+        final @NotNull World world,
+        final @NotNull Dimension dimension
+    ) {
         super(world, dimension);
     }
 
-    public WorldClient(LevelStorage saveHandler, String name, Dimension dimension, WorldType worldType, long seed) {
-        super(saveHandler, name, dimension, worldType, seed);
+    public WorldClient(
+        final @NotNull SavedDataStorage savedDataStorage,
+        final @NotNull String name,
+        final long seed,
+        final @NotNull Dimension dimension,
+        final @NotNull WorldType worldType
+    ) {
+        super(savedDataStorage, name, seed, dimension, worldType);
     }
 
     public WorldClient() {
         this.dimension = Dimension.OVERWORLD;
-        this.saveHandler = null;
-        this.levelData = new LevelData(0, "modelviewer");
         this.worldType = WorldTypes.DEBUG;
         this.chunkProvider = new ChunkProviderViewer(this);
         this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
@@ -53,8 +65,6 @@ public class WorldClient extends World {
 
         this.weatherManager = new WeatherManager(this);
 
-        this.auroraProvider = new AuroraProvider(this, 0);
-
         this.biomeProvider = this.worldType.createBiomeProvider(this);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 7388c1042..1cd0a5b1c 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -13,7 +13,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
-import net.minecraft.client.world.save.SaveHandlerClientMP;
+import net.minecraft.core.world.save.LevelStorageDummy;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -32,21 +32,32 @@ public class WorldClientMP extends WorldClient {
     private final Set<Entity> forced;
     private final Set<Entity> reEntries;
 
-    public WorldClientMP(PacketHandlerClient packetHandlerClient, long seed, int dimensionId, int worldTypeId) {
-        super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
+    public WorldClientMP(
+        final @NotNull PacketHandlerClient packetHandler,
+        final long seed,
+        final int dimensionId,
+        final int worldTypeId
+    ) {
+        super(
+            packetHandler.savedDataStorage,
+            "MpServer",
+            seed,
+            Dimension.getDimensionList().get(dimensionId),
+            Registries.WORLD_TYPES.getItemByNumericId(worldTypeId)
+        );
+
         this.positionTypesList = new LinkedList<>();
         this.entitiesById = new Int2ObjectOpenHashMap<>();
         this.forced = new HashSet<>();
         this.reEntries = new HashSet<>();
-        this.sendQueue = packetHandlerClient;
+        this.sendQueue = packetHandler;
         setSpawnPoint(new ChunkCoordinates(8, 64, 8));
-        this.savedDataStorage = packetHandlerClient.savedDataStorage;
     }
 
     @Override
     public void tick() {
         if (getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
-            this.levelData.setWorldTime(this.levelData.getWorldTime() + 1L);
+            this.getLevelData().setWorldTime(this.getLevelData().getWorldTime() + 1L);
         }
         for (int k = 0; k < 10 && !this.reEntries.isEmpty(); k++) {
             Entity entity = this.reEntries.iterator().next();
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java b/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
similarity index 87%
rename from game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
rename to game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
index ccccb4233..2d4ff4e49 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/save/LevelStorageClientSP.java
@@ -7,17 +7,17 @@ import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.save.SaveHandlerBase;
+import net.minecraft.core.world.save.LevelStorageBase;
 import org.jetbrains.annotations.NotNull;
 
 import java.io.File;
 import java.util.List;
 
-public class SaveHandlerClientSP
-        extends SaveHandlerBase
+public class LevelStorageClientSP
+        extends LevelStorageBase
 {
 
-    public SaveHandlerClientSP(ISaveFormat saveFormat, File savesDir, String worldDirName)
+    public LevelStorageClientSP(ISaveFormat saveFormat, File savesDir, String worldDirName)
     {
         super(saveFormat, savesDir, worldDirName);
     }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index efffcdb57..594e0819a 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -373,21 +373,6 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                     lightTL = lightBL = lightBR = lightTR = getBrightness(dirX2, dirY2, dirZ2, minBrightness);
                 }
 
-                float colorRedBottomLeft = r;
-                float colorRedBottomRight = colorRedBottomLeft;
-                float colorRedTopRight = colorRedBottomLeft;
-                float colorRedTopLeft = colorRedBottomLeft;
-
-                float colorGreenBottomLeft = g;
-                float colorGreenBottomRight = colorGreenBottomLeft;
-                float colorGreenTopRight = colorGreenBottomLeft;
-                float colorGreenTopLeft = colorGreenBottomLeft;
-
-                float colorBlueBottomLeft = b;
-                float colorBlueBottomRight = colorBlueBottomLeft;
-                float colorBlueTopRight = colorBlueBottomLeft;
-                float colorBlueTopLeft = colorBlueBottomLeft;
-
                 final float tl = topP * lightTL + (1 - topP) * lightBL;
                 final float tr = topP * lightTR + (1 - topP) * lightBR;
                 final float bl = botP * lightTL + (1 - botP) * lightBL;
@@ -420,7 +405,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 }
                 Vector2fc uvsTL = element.vertexUvs[offset + VERTEX_TOP_LEFT];
                 if (uvlock) uvsTL = rotateUV(uvsTL, rotX, rotY, rotZ, element.directions[face], this.vertUV);
-                tessellator.setColorOpaque3f(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
+                tessellator.setColorOpaque3f(r, g, b);
                 tessellator.setLightmapCoord1i(lightIndexTopLeft);
                 tessellator.setShade1i((int) (ltl * 0xFF));
                 tessellator.addVertexWithUV(
@@ -440,7 +425,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 }
                 Vector2fc uvsBL = element.vertexUvs[offset + VERTEX_BOTTOM_LEFT];
                 if (uvlock) uvsBL = rotateUV(uvsBL, rotX, rotY, rotZ, element.directions[face], this.vertUV);
-                tessellator.setColorOpaque3f(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
+                tessellator.setColorOpaque3f(r, g, b);
                 tessellator.setLightmapCoord1i(lightIndexBottomLeft);
                 tessellator.setShade1i((int) (lbl * 0xFF));
                 tessellator.addVertexWithUV(
@@ -460,7 +445,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 }
                 Vector2fc uvsBR = element.vertexUvs[offset + VERTEX_BOTTOM_RIGHT];
                 if (uvlock) uvsBR = rotateUV(uvsBR, rotX, rotY, rotZ, element.directions[face], this.vertUV);
-                tessellator.setColorOpaque3f(colorRedBottomRight, colorGreenBottomRight, colorBlueBottomRight);
+                tessellator.setColorOpaque3f(r, g, b);
                 tessellator.setLightmapCoord1i(lightIndexBottomRight);
                 tessellator.setShade1i((int) (lbr * 0xFF));
                 tessellator.addVertexWithUV(
@@ -480,7 +465,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 }
                 Vector2fc uvsTR = element.vertexUvs[offset + VERTEX_TOP_RIGHT];
                 if (uvlock) uvsTR = rotateUV(uvsTR, rotX, rotY, rotZ, element.directions[face], this.vertUV);
-                tessellator.setColorOpaque3f(colorRedTopRight, colorGreenTopRight, colorBlueTopRight);
+                tessellator.setColorOpaque3f(r, g, b);
                 tessellator.setLightmapCoord1i(lightIndexTopRight);
                 tessellator.setShade1i((int) (ltr * 0xFF));
                 tessellator.addVertexWithUV(
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index d80227c35..229c9771e 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -2,8 +2,11 @@
 out vec4 FragColor;
 
 in vec4 Color;
+in vec2 UV;
 in vec2 TexCoord;
 in vec2 Lightmap;
+in vec2 Size;
+in float Config;
 
 uniform float uAlphaTest;
 uniform vec4 uColor;
@@ -11,8 +14,65 @@ uniform vec4 uColor;
 uniform sampler2D colortex;
 uniform sampler2D lighttex;
 
+bool sampleInside(vec2 tex) {
+    vec2 max = UV + (Size/128);
+    return tex.x > UV.x && tex.y > UV.y && tex.x < max.x && tex.y < max.y;
+}
+
+vec4 colorAtPoint(vec2 point) {
+    uint config = uint(Config + 0.01);
+    vec4 tint = texture(lighttex, Lightmap) * uColor;
+
+    vec4 color = vec4(0, 0, 0, 0);
+    if (sampleInside(point)) {
+        color = texture(colortex, point) * Color * tint;
+    }
+    vec2 left = point - vec2(1, 0)/128;
+    if ((config & 0x08u) != 0 && sampleInside(left) && length(color) == 0) {
+        color = texture(colortex, left) * Color * tint;
+    }
+    vec2 max = UV + (Size/128);
+    if ((config & 0x02u) != 0 && point.y > max.y && point.y < (max.y + 1.0/128)) {
+        color = Color * tint;
+    }
+    vec2 mid = UV + Size/256;
+    if ((config & 0x04u) != 0 && point.y > (mid.y - 1.0/128) && point.y < mid.y) {
+        color = Color * tint;
+    }
+
+    return color;
+}
+
+
+bool canReplace(vec2 tex) {
+    return length(colorAtPoint(tex)) != 0;
+}
+
+
 void main() {
-    FragColor = texture(colortex, TexCoord) * texture(lighttex, Lightmap) * Color * uColor;
+    uint config = uint(Config + 0.01);
+    vec4 tint = texture(lighttex, Lightmap) * uColor;
+    FragColor = colorAtPoint(TexCoord);
+    if (length(FragColor) == 0) {
+        if ((config & 0x20u) != 0) {
+            vec2 upLeft = TexCoord + vec2(-1, -1)/128;
+            vec2 up = TexCoord + vec2(0, -1)/128;
+            vec2 upRight = TexCoord + vec2(1, -1)/128;
+            vec2 left = TexCoord + vec2(-1, 0)/128;
+            vec2 right = TexCoord + vec2(1, 0)/128;
+            vec2 downLeft = TexCoord + vec2(-1, 1)/128;
+            vec2 down = TexCoord + vec2(0, 1)/128;
+            vec2 downRight = TexCoord + vec2(1, 1)/128;
+            if (canReplace(upLeft) || canReplace(up) || canReplace(upRight) || canReplace(left) || canReplace(right) || canReplace(downLeft) || canReplace(down) || canReplace(downRight)) {
+                FragColor = vec4(Color.rgb/4, Color.a) * tint;
+            }
+        } else if ((config & 0x80u) != 0) {
+            vec2 upLeft = TexCoord - vec2(1, 1)/128;
+            if (canReplace(upLeft)) {
+                FragColor = vec4(Color.rgb/4, Color.a) * tint;
+            }
+        }
+    }
     if (FragColor.a < uAlphaTest) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/font.gsh b/game/client/src/main/resources/shaders/font.gsh
index c3c377ebc..f036b47c1 100644
--- a/game/client/src/main/resources/shaders/font.gsh
+++ b/game/client/src/main/resources/shaders/font.gsh
@@ -4,16 +4,18 @@ layout (triangle_strip, max_vertices = 4) out;
 
 in VS_OUT {
     vec2 size;
-    float shift;
     vec4 color;
     vec2 uv;
-    vec2 uvSizes;
     vec2 lightmap;
+    float config;
 } gs_in[];
 
 out vec4 Color;
+out vec2 UV;
 out vec2 TexCoord;
 out vec2 Lightmap;
+out vec2 Size;
+out float Config;
 
 uniform mat4 model;
 layout (std140) uniform Matrices {
@@ -24,23 +26,28 @@ layout (std140) uniform Matrices {
 } matrices;
 
 void main() {
+    UV = gs_in[0].uv;
+    Size = gs_in[0].size;
+    Config = gs_in[0].config;
     Color = gs_in[0].color;
     Lightmap = gs_in[0].lightmap;
 
-    TexCoord = gs_in[0].uv + vec2(0, gs_in[0].uvSizes.y);
-    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(-gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    float shift = uint(gs_in[0].config) & 0x01u;
+
+    TexCoord = gs_in[0].uv + vec2(-1, gs_in[0].size.y + 2)/128;
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(-shift - 1,  gs_in[0].size.y + 2, 0.0, 0.0));
     EmitVertex();
 
-    TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, gs_in[0].uvSizes.y);
-    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x - gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    TexCoord = gs_in[0].uv + vec2(gs_in[0].size.x + 2, gs_in[0].size.y + 2)/128;
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x - shift + 2,  gs_in[0].size.y + 2, 0.0, 0.0));
     EmitVertex();
 
-    TexCoord = gs_in[0].uv + vec2(0, 0);
-    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].shift, 0, 0.0, 0.0));
+    TexCoord = gs_in[0].uv + vec2(-1, -1)/128;
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(shift - 1, - 1, 0.0, 0.0));
     EmitVertex();
 
-    TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, 0);
-    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x + gs_in[0].shift, 0, 0.0, 0.0));
+    TexCoord = gs_in[0].uv + vec2(gs_in[0].size.x + 2, -1)/128;
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x + shift + 2, -1, 0.0, 0.0));
     EmitVertex();
 
     EndPrimitive();
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
index 573276518..12aa80801 100644
--- a/game/client/src/main/resources/shaders/font.vsh
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -1,19 +1,17 @@
 #version 410 core
 layout (location = 0) in vec2 aPos;
 layout (location = 1) in vec2 aSize;
-layout (location = 2) in float aShift;
-layout (location = 3) in vec4 aColor;
-layout (location = 4) in vec2 aUv;
-layout (location = 5) in vec2 aUvSizes;
-layout (location = 6) in float aLightmap;
+layout (location = 2) in vec4 aColor;
+layout (location = 3) in vec2 aUV;
+layout (location = 4) in float aConfig;
+layout (location = 5) in float aLightmap;
 
 out VS_OUT {
     vec2 size;
-    float shift;
     vec4 color;
     vec2 uv;
-    vec2 uvSizes;
     vec2 lightmap;
+    float config;
 } vs_out;
 
 uniform float uZ;
@@ -26,10 +24,9 @@ vec2 unpackLightCoord() {
 void main() {
     gl_Position = vec4(aPos, uZ, 1);
 
-    vs_out.size = aSize;
-    vs_out.shift = aShift;
+    vs_out.size = aSize/2;
     vs_out.color = aColor;
-    vs_out.uv = aUv/256.0;
-    vs_out.uvSizes = aUvSizes/256.0;
+    vs_out.uv = aUV/256.0;
     vs_out.lightmap = unpackLightCoord();
+    vs_out.config = aConfig;
 }
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index e4d7c4da6..b1e31ee04 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -78,7 +78,7 @@ void main() {
 
     vec4 c = vec4(mix(vec3(1, 1, 1), Color.rgb, maskColor.r), 1) * uColor;
 
-    vec4 postColor = texColor * c * Shade * lightColor;
+    vec4 postColor = texColor * c * vec4(Shade, Shade, Shade, 1) * lightColor;
     vec4 litColor = vec4(postColor.rgb * clamp(Light, 0, 1), postColor.a);
 //    vec4 litColor = vec4(abs(Norm), 1f);
 
diff --git a/game/client/src/main/resources/shaders/terrain.gsh b/game/client/src/main/resources/shaders/terrain.gsh
index 41418cffa..d275532da 100644
--- a/game/client/src/main/resources/shaders/terrain.gsh
+++ b/game/client/src/main/resources/shaders/terrain.gsh
@@ -2,6 +2,9 @@
 layout (points) in;
 layout (triangle_strip, max_vertices = 4) out;
 
+#define EXPAND_POS 1.0005
+#define EXPAND_UV 0.995
+
 in VS_OUT {
     vec3 sourcePos;
     vec3 sourceColor;
@@ -75,30 +78,30 @@ void main() {
 
     Color = vec4(gs_in[0].sourceColor, 1);
     Shade = unpackShade(gs_in[0].V1LightShade);
-    TexCoord = expand(gs_in[0].V1UV, uvCenter, 0.995f);
+    TexCoord = expand(gs_in[0].V1UV, uvCenter, EXPAND_UV);
     LightMapCoord = unpackLightCoord(gs_in[0].V1LightShade);
-    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos, posCenter, 1.0005f), 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos, posCenter, EXPAND_POS), 1);
     EmitVertex();
 
     Color = vec4(gs_in[0].sourceColor, 1);
     Shade = unpackShade(gs_in[0].V2LightShade);
-    TexCoord = expand(gs_in[0].V2UV, uvCenter, 0.995f);
+    TexCoord = expand(gs_in[0].V2UV, uvCenter, EXPAND_UV);
     LightMapCoord = unpackLightCoord(gs_in[0].V2LightShade);
-    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V2PosOffset, posCenter, 1.0005f), 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V2PosOffset, posCenter, EXPAND_POS), 1);
     EmitVertex();
 
     Color = vec4(gs_in[0].sourceColor, 1);
     Shade = unpackShade(gs_in[0].V4LightShade);
-    TexCoord = expand(gs_in[0].V4UV, uvCenter, 0.995f);
+    TexCoord = expand(gs_in[0].V4UV, uvCenter, EXPAND_UV);
     LightMapCoord = unpackLightCoord(gs_in[0].V4LightShade);
-    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V4PosOffset, posCenter, 1.0005f), 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V4PosOffset, posCenter, EXPAND_POS), 1);
     EmitVertex();
 
     Color = vec4(gs_in[0].sourceColor, 1);
     Shade = unpackShade(gs_in[0].V3LightShade);
-    TexCoord = expand(gs_in[0].V3UV, uvCenter, 0.995f);
+    TexCoord = expand(gs_in[0].V3UV, uvCenter, EXPAND_UV);
     LightMapCoord = unpackLightCoord(gs_in[0].V3LightShade);
-    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V3PosOffset, posCenter, 1.0005f), 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(expand(gs_in[0].sourcePos + gs_in[0].V3PosOffset, posCenter, EXPAND_POS), 1);
     EmitVertex();
 
     EndPrimitive();
diff --git a/game/client/src/test/java/TestBlockModelDispatcher.java b/game/client/src/test/java/TestBlockModelDispatcher.java
index 9130ef2aa..71a402c01 100644
--- a/game/client/src/test/java/TestBlockModelDispatcher.java
+++ b/game/client/src/test/java/TestBlockModelDispatcher.java
@@ -1,3 +1,4 @@
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -10,6 +11,11 @@ public class TestBlockModelDispatcher {
     @DisplayName("Verify block models")
     public void veryBlockModels() {
         Blocks.init();
+
+        // Models require mc reference
+        //noinspection DataFlowIssue
+        new Minecraft(Minecraft.getAppDir("minecraft-bta"), null);
+
         for (Block<?> block : Blocks.blockMap.values()) {
             Assertions.assertTrue(BlockModelDispatcher.getInstance().hasDispatch(block), () -> "Block '" + block.namespaceId() + "' is not assigned a block model!");
         }
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index d374f8e0e..ccc59f52f 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -67,7 +67,6 @@ val versionGenerator by tasks.registering {
 
                     public final class Version {
                         public static final String VERSION = "$version";
-                        public static final long BUILD_TIME = ${Date().time}L;
                         public static final int ASSET_PACK_FORMAT = $assetPackFormat;
                         public static final BuildChannel BUILD_CHANNEL = $buildChannel;
                         public static final int MP_PROTOCOL_VERSION = ${genProtocol(version, buildChannel)};
diff --git a/game/core/src/main/java/net/minecraft/core/Global.java b/game/core/src/main/java/net/minecraft/core/Global.java
index e8ea1ada8..9dceda8e8 100644
--- a/game/core/src/main/java/net/minecraft/core/Global.java
+++ b/game/core/src/main/java/net/minecraft/core/Global.java
@@ -4,10 +4,9 @@ import org.jetbrains.annotations.NotNull;
 
 public class Global
 {
-	public static final int TICKS_PER_SECOND = 20;
+	public static final int TICKS_PER_SECOND = 21;
 	public static final int DAY_LENGTH_TICKS = 24000;
 	public static final @NotNull String VERSION = Version.BUILD_CHANNEL.modifyVersionString(Version.VERSION);
-	public static final long BUILD_TIME = Version.BUILD_TIME;
 	public static final @NotNull BuildChannel BUILD_CHANNEL = Version.BUILD_CHANNEL;
 	public static final int CURRENT_SAVE_VERSION = 19134;
 	public static final int CURRENT_CHUNK_VERSION = 3;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 8d3c3a8d7..05e21f11c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.util.helper.UUIDHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -187,7 +188,6 @@ public class TileEntityFlag extends TileEntity
 
     @Override
     public @Nullable ItemStack getItem(int slot) {
-        slot -= 36;
         if (slot < 0 || slot >= 3) return null;
         
         return items[slot];
@@ -195,7 +195,6 @@ public class TileEntityFlag extends TileEntity
 
     @Override
     public @Nullable ItemStack removeItem(int slot, int takeAmount) {
-        slot -= 36;
         if (items[slot] != null)
         {
             if (items[slot].stackSize <= takeAmount)
@@ -232,7 +231,6 @@ public class TileEntityFlag extends TileEntity
     @Override
     public void setItem(int slot, @Nullable ItemStack stack)
     {
-        slot -= 36; // This seems so wrong and will almost certainly cause an issue at some point
         items[slot] = stack;
         itemsChanges();
         setChanged();
